Index: palm/trunk/SOURCE/land_surface_model_mod.f90
===================================================================
--- palm/trunk/SOURCE/land_surface_model_mod.f90	(revision 4670)
+++ palm/trunk/SOURCE/land_surface_model_mod.f90	(revision 4671)
@@ -4543,15 +4630,17 @@
 
              IF ( init_3d%lod_msoil == 1 )  THEN
-                DO  m = 1, surf_lsm_h%ns
-                   IF ( surf_lsm_h%vegetation_surface(m)  .OR.                 &
-                        surf_lsm_h%pavement_surface(m) )  THEN
-
-                      CALL interpolate_soil_profile(                           &
-                                       m_soil_h%var_2d(nzb_soil:nzt_soil,m),   &
-                                       init_3d%msoil_1d(:),                    &
-                                       zs(nzb_soil:nzt_soil), init_3d%z_soil,  &
-                                       nzb_soil, nzt_soil,                     &
-                                       nzb_soil, init_3d%nzs-1 )
-                   ENDIF
+                DO  l = 0, 1
+                   DO  m = 1, surf_lsm_h(l)%ns
+                      IF ( surf_lsm_h(l)%vegetation_surface(m)  .OR.                 &
+                           surf_lsm_h(l)%pavement_surface(m) )  THEN
+
+                         CALL interpolate_soil_profile(                           &
+                                          m_soil_h(l)%var_2d(nzb_soil:nzt_soil,m),&
+                                          init_3d%msoil_1d(:),                    &
+                                          zs(nzb_soil:nzt_soil), init_3d%z_soil,  &
+                                          nzb_soil, nzt_soil,                     &
+                                          nzb_soil, init_3d%nzs-1 )
+                      ENDIF
+                   ENDDO
                 ENDDO
                 DO  l = 0, 3
@@ -4569,19 +4658,20 @@
                 ENDDO
              ELSE
-
-                DO  m = 1, surf_lsm_h%ns
-                   IF ( surf_lsm_h%vegetation_surface(m)  .OR.                 &
-                        surf_lsm_h%pavement_surface(m) )  THEN
-                      i = surf_lsm_h%i(m)
-                      j = surf_lsm_h%j(m)
-
-                      IF ( init_3d%msoil_3d(0,j,i) /= init_3d%fill_msoil )     &
-                         CALL interpolate_soil_profile(                        &
-                                       m_soil_h%var_2d(nzb_soil:nzt_soil,m),   &
-                                       init_3d%msoil_3d(:,j,i),                &
-                                       zs(nzb_soil:nzt_soil), init_3d%z_soil,  &
-                                       nzb_soil, nzt_soil,                     &
-                                       nzb_soil, init_3d%nzs-1 )
-                   ENDIF
+                DO  l = 0, 1
+                   DO  m = 1, surf_lsm_h(l)%ns
+                      IF ( surf_lsm_h(l)%vegetation_surface(m)  .OR.                 &
+                           surf_lsm_h(l)%pavement_surface(m) )  THEN
+                         i = surf_lsm_h(l)%i(m)
+                         j = surf_lsm_h(l)%j(m)
+
+                         IF ( init_3d%msoil_3d(0,j,i) /= init_3d%fill_msoil )     &
+                            CALL interpolate_soil_profile(                        &
+                                          m_soil_h(l)%var_2d(nzb_soil:nzt_soil,m),&
+                                          init_3d%msoil_3d(:,j,i),                &
+                                          zs(nzb_soil:nzt_soil), init_3d%z_soil,  &
+                                          nzb_soil, nzt_soil,                     &
+                                          nzb_soil, init_3d%nzs-1 )
+                      ENDIF
+                   ENDDO
                 ENDDO
                 DO  l = 0, 3
@@ -4614,17 +4704,19 @@
 
              IF ( init_3d%lod_tsoil == 1 )  THEN ! change to 1 if provided correctly by INIFOR
-                DO  m = 1, surf_lsm_h%ns
-                   IF ( surf_lsm_h%vegetation_surface(m)  .OR.                 &
-                        surf_lsm_h%pavement_surface(m) )  THEN
-                      CALL interpolate_soil_profile(                           &
-                                       t_soil_h%var_2d(nzb_soil:nzt_soil,m),   &
-                                       init_3d%tsoil_1d(:),                    &
-                                       zs(nzb_soil:nzt_soil), init_3d%z_soil,  &
-                                       nzb_soil, nzt_soil,                     &
-                                       nzb_soil, init_3d%nzs-1 )
-!
-!--                   Set boundary condition, i.e. deep soil temperature
-                      t_soil_h%var_2d(nzt_soil+1,m) = t_soil_h%var_2d(nzt_soil,m)
-                   ENDIF
+                DO  l = 0, 1
+                   DO  m = 1, surf_lsm_h(l)%ns
+                      IF ( surf_lsm_h(l)%vegetation_surface(m)  .OR.                 &
+                           surf_lsm_h(l)%pavement_surface(m) )  THEN
+                         CALL interpolate_soil_profile(                           &
+                                          t_soil_h(l)%var_2d(nzb_soil:nzt_soil,m),   &
+                                          init_3d%tsoil_1d(:),                    &
+                                          zs(nzb_soil:nzt_soil), init_3d%z_soil,  &
+                                          nzb_soil, nzt_soil,                     &
+                                          nzb_soil, init_3d%nzs-1 )
+   !
+   !--                   Set boundary condition, i.e. deep soil temperature
+                         t_soil_h(l)%var_2d(nzt_soil+1,m) = t_soil_h(l)%var_2d(nzt_soil,m)
+                      ENDIF
+                   ENDDO
                 ENDDO
                 DO  l = 0, 3
@@ -4646,22 +4738,23 @@
                 ENDDO
              ELSE
-
-                DO  m = 1, surf_lsm_h%ns
-                   IF ( surf_lsm_h%vegetation_surface(m)  .OR.                 &
-                        surf_lsm_h%pavement_surface(m) )  THEN
-                      i = surf_lsm_h%i(m)
-                      j = surf_lsm_h%j(m)
-
-                      IF ( init_3d%tsoil_3d(0,j,i) /= init_3d%fill_tsoil )     &
-                         CALL interpolate_soil_profile(                        &
-                                       t_soil_h%var_2d(nzb_soil:nzt_soil,m),   &
-                                       init_3d%tsoil_3d(:,j,i),                &
-                                       zs(nzb_soil:nzt_soil), init_3d%z_soil,  &
-                                       nzb_soil, nzt_soil,                     &
-                                       nzb_soil, init_3d%nzs-1 )
-!
-!--                   Set boundary condition, i.e. deep soil temperature
-                      t_soil_h%var_2d(nzt_soil+1,m) = t_soil_h%var_2d(nzt_soil,m)
-                   ENDIF
+                DO  l = 0, 1
+                   DO  m = 1, surf_lsm_h(l)%ns
+                      IF ( surf_lsm_h(l)%vegetation_surface(m)  .OR.                 &
+                           surf_lsm_h(l)%pavement_surface(m) )  THEN
+                         i = surf_lsm_h(l)%i(m)
+                         j = surf_lsm_h(l)%j(m)
+
+                         IF ( init_3d%tsoil_3d(0,j,i) /= init_3d%fill_tsoil )     &
+                            CALL interpolate_soil_profile(                        &
+                                          t_soil_h(l)%var_2d(nzb_soil:nzt_soil,m),   &
+                                          init_3d%tsoil_3d(:,j,i),                &
+                                          zs(nzb_soil:nzt_soil), init_3d%z_soil,  &
+                                          nzb_soil, nzt_soil,                     &
+                                          nzb_soil, init_3d%nzs-1 )
+   !
+   !--                   Set boundary condition, i.e. deep soil temperature
+                         t_soil_h(l)%var_2d(nzt_soil+1,m) = t_soil_h(l)%var_2d(nzt_soil,m)
+                      ENDIF
+                   ENDDO
                 ENDDO
                 DO  l = 0, 3
@@ -4699,18 +4792,20 @@
 !--       point errors. Hence, limit the soil moisture to its saturation value
 !--       and give a warning.
-          DO  m = 1, surf_lsm_h%ns
-             IF ( surf_lsm_h%vegetation_surface(m)  .OR.                       &
-                  surf_lsm_h%pavement_surface(m) )  THEN
-                DO  k = nzb_soil, nzt_soil
-                   IF ( m_soil_h%var_2d(k,m) > surf_lsm_h%m_sat(k,m) )  THEN
-                      m_soil_h%var_2d(k,m) = surf_lsm_h%m_sat(k,m)
-                      WRITE( message_string, * ) 'soil moisture is higher '//  &
-                            'than its saturation value at (k,j,i) ', k,        &
-                            surf_lsm_h%i(m), surf_lsm_h%j(m), ' and is ' //    &
-                            'thus limited to this value to maintain stability.'
-                      CALL message( 'lsm_init', 'PA0458', 0, 1, myid, 6, 0 )
-                   ENDIF
-                ENDDO
-             ENDIF
+          DO l = 0, 1
+             DO  m = 1, surf_lsm_h(l)%ns
+                IF ( surf_lsm_h(l)%vegetation_surface(m)  .OR.                       &
+                     surf_lsm_h(l)%pavement_surface(m) )  THEN
+                   DO  k = nzb_soil, nzt_soil
+                      IF ( m_soil_h(l)%var_2d(k,m) > surf_lsm_h(l)%m_sat(k,m) )  THEN
+                         m_soil_h(l)%var_2d(k,m) = surf_lsm_h(l)%m_sat(k,m)
+                         WRITE( message_string, * ) 'soil moisture is higher '//     &
+                               'than its saturation value at (k,j,i) ', k,           &
+                               surf_lsm_h(l)%i(m), surf_lsm_h(l)%j(m), ' and is ' // &
+                               'thus limited to this value to maintain stability.'
+                         CALL message( 'lsm_init', 'PA0458', 0, 1, myid, 6, 0 )
+                      ENDIF
+                   ENDDO
+                ENDIF
+             ENDDO
           ENDDO
           DO  l = 0, 3
@@ -4737,30 +4832,32 @@
 !
 !--       Further initialization
-          DO  m = 1, surf_lsm_h%ns
-
-             i   = surf_lsm_h%i(m)
-             j   = surf_lsm_h%j(m)
-             k   = surf_lsm_h%k(m)
-!
-!--          Initialize surface temperature with soil temperature in the uppermost
-!--          uppermost layer
-             t_surface_h%var_1d(m)    = t_soil_h%var_2d(nzb_soil,m)
-             surf_lsm_h%pt_surface(m) = t_soil_h%var_2d(nzb_soil,m) / exner(nzb)
-
-             IF ( bulk_cloud_model  .OR. cloud_droplets ) THEN
-                surf_lsm_h%pt1(m) = pt(k,j,i) + lv_d_cp * d_exner(k) * ql(k,j,i)
-             ELSE
-                surf_lsm_h%pt1(m) = pt(k,j,i)
-             ENDIF
-!
-!--          Assure that r_a cannot be zero at model start
-             IF ( surf_lsm_h%pt1(m) == surf_lsm_h%pt_surface(m) )              &
-                surf_lsm_h%pt1(m) = surf_lsm_h%pt1(m) + 1.0E-20_wp
-
-             surf_lsm_h%us(m)   = 0.1_wp
-             surf_lsm_h%ts(m)   = ( surf_lsm_h%pt1(m) - surf_lsm_h%pt_surface(m) )&
-                                  / surf_lsm_h%r_a(m)
-             surf_lsm_h%shf(m)  = - surf_lsm_h%us(m) * surf_lsm_h%ts(m)        &
-                                  * rho_surface
+          DO l = 0, 1
+             DO  m = 1, surf_lsm_h(l)%ns
+
+                i   = surf_lsm_h(l)%i(m)
+                j   = surf_lsm_h(l)%j(m)
+                k   = surf_lsm_h(l)%k(m)
+   !
+   !--          Initialize surface temperature with soil temperature in the uppermost
+   !--          uppermost layer
+                t_surface_h(l)%var_1d(m)    = t_soil_h(l)%var_2d(nzb_soil,m)
+                surf_lsm_h(l)%pt_surface(m) = t_soil_h(l)%var_2d(nzb_soil,m) / exner(nzb)
+
+                IF ( bulk_cloud_model  .OR. cloud_droplets ) THEN
+                   surf_lsm_h(l)%pt1(m) = pt(k,j,i) + lv_d_cp * d_exner(k) * ql(k,j,i)
+                ELSE
+                   surf_lsm_h(l)%pt1(m) = pt(k,j,i)
+                ENDIF
+   !
+   !--          Assure that r_a cannot be zero at model start
+                IF ( surf_lsm_h(l)%pt1(m) == surf_lsm_h(l)%pt_surface(m) )              &
+                   surf_lsm_h(l)%pt1(m) = surf_lsm_h(l)%pt1(m) + 1.0E-20_wp
+
+                surf_lsm_h(l)%us(m)   = 0.1_wp
+                surf_lsm_h(l)%ts(m)   = ( surf_lsm_h(l)%pt1(m) - surf_lsm_h(l)%pt_surface(m) )&
+                                     / surf_lsm_h(l)%r_a(m)
+                surf_lsm_h(l)%shf(m)  = - surf_lsm_h(l)%us(m) * surf_lsm_h(l)%ts(m)        &
+                                     * rho_surface
+             ENDDO
           ENDDO
 !
@@ -4802,7 +4899,9 @@
 !--    Level 1 initialization of root distribution - provided by the user via
 !--    via namelist.
-       DO  m = 1, surf_lsm_h%ns
-          DO  k = nzb_soil, nzt_soil
-             surf_lsm_h%root_fr(k,m) = root_fraction(k)
+       DO l = 0, 1
+          DO  m = 1, surf_lsm_h(l)%ns
+             DO  k = nzb_soil, nzt_soil
+                surf_lsm_h(l)%root_fr(k,m) = root_fraction(k)
+             ENDDO
           ENDDO
        ENDDO
@@ -4874,23 +4973,25 @@
 !
 !--       Map calculated root fractions
-          DO  m = 1, surf_lsm_h%ns
-             DO  k = nzb_soil, nzt_soil
-                IF ( surf_lsm_h%pavement_surface(m)  .AND.                     &
-                     k <= surf_lsm_h%nzt_pavement(m) )  THEN
-                   surf_lsm_h%root_fr(k,m) = 0.0_wp
-                ELSE
-                   surf_lsm_h%root_fr(k,m) = root_fraction(k)
+          DO  l = 0, 1
+                DO  m = 1, surf_lsm_h(l)%ns
+                   DO  k = nzb_soil, nzt_soil
+                      IF ( surf_lsm_h(l)%pavement_surface(m)  .AND.                     &
+                           k <= surf_lsm_h(l)%nzt_pavement(m) )  THEN
+                         surf_lsm_h(l)%root_fr(k,m) = 0.0_wp
+                      ELSE
+                         surf_lsm_h(l)%root_fr(k,m) = root_fraction(k)
+                      ENDIF
+
+                   ENDDO
+!
+!--             Normalize so that the sum = 1. Only relevant when the root
+!--             distribution was set to zero due to pavement at some layers.
+                IF ( SUM( surf_lsm_h(l)%root_fr(:,m) ) > 0.0_wp )  THEN
+                   DO k = nzb_soil, nzt_soil
+                      surf_lsm_h(l)%root_fr(k,m) = surf_lsm_h(l)%root_fr(k,m)           &
+                      / SUM( surf_lsm_h(l)%root_fr(:,m) )
+                   ENDDO
                 ENDIF
-
-             ENDDO
-!
-!--          Normalize so that the sum = 1. Only relevant when the root
-!--          distribution was set to zero due to pavement at some layers.
-             IF ( SUM( surf_lsm_h%root_fr(:,m) ) > 0.0_wp )  THEN
-                DO k = nzb_soil, nzt_soil
-                   surf_lsm_h%root_fr(k,m) = surf_lsm_h%root_fr(k,m)           &
-                   / SUM( surf_lsm_h%root_fr(:,m) )
-                ENDDO
-             ENDIF
+             ENDDO
           ENDDO
           DO  l = 0, 3
@@ -4920,15 +5021,16 @@
 !--    Take value from file
        IF ( root_area_density_lsm_f%from_file )  THEN
-          DO  m = 1, surf_lsm_h%ns
-             IF ( surf_lsm_h%vegetation_surface(m) )  THEN
-                i = surf_lsm_h%i(m)
-                j = surf_lsm_h%j(m)
-                DO  k = nzb_soil, nzt_soil
-                   surf_lsm_h%root_fr(k,m) = root_area_density_lsm_f%var(k,j,i)
-                ENDDO
-
-             ENDIF
+          DO  l = 0, 1
+             DO  m = 1, surf_lsm_h(l)%ns
+                IF ( surf_lsm_h(l)%vegetation_surface(m) )  THEN
+                   i = surf_lsm_h(l)%i(m)
+                   j = surf_lsm_h(l)%j(m)
+                   DO  k = nzb_soil, nzt_soil
+                      surf_lsm_h(l)%root_fr(k,m) = root_area_density_lsm_f%var(k,j,i)
+                   ENDDO
+
+                ENDIF
+             ENDDO
           ENDDO
-
           DO  l = 0, 3
              DO  m = 1, surf_lsm_v(l)%ns
@@ -4983,12 +5085,13 @@
 !--    Finally, make some consistency checks.
 !--    Ceck for illegal combination of LAI and vegetation coverage.
-       IF ( ANY( .NOT. surf_lsm_h%pavement_surface  .AND.                      &
-                 surf_lsm_h%lai == 0.0_wp  .AND.  surf_lsm_h%c_veg == 1.0_wp ) &
-          )  THEN
-          message_string = 'For non-pavement surfaces the combination ' //     &
-                           ' lai = 0.0 and c_veg = 1.0 is not allowed.'
-          CALL message( 'lsm_init', 'PA0671', 2, 2, myid, 6, 0 )
-       ENDIF
-
+       DO  l = 0, 1
+          IF ( ANY( .NOT. surf_lsm_h(l)%pavement_surface  .AND.                      &
+                    surf_lsm_h(l)%lai == 0.0_wp  .AND.  surf_lsm_h(l)%c_veg == 1.0_wp ) &
+             )  THEN
+             message_string = 'For non-pavement surfaces the combination ' //     &
+                              ' lai = 0.0 and c_veg = 1.0 is not allowed.'
+             CALL message( 'lsm_init', 'PA0671', 2, 2, myid, 6, 0 )
+          ENDIF
+       ENDDO
        DO  l = 0, 3
           IF ( ANY( .NOT. surf_lsm_v(l)%pavement_surface  .AND.                &
@@ -5005,16 +5108,19 @@
 !--    necessary. This case, give an informative message. Note, to avoid
 !--    that the job-protocoll is messed-up, this message is only given once.
+!--    ???what about the vertical surfaces???
        flag_exceed_z0  = .FALSE.
        flag_exceed_z0h = .FALSE.
-       DO  m = 1, surf_lsm_h%ns
-          IF ( surf_lsm_h%z0(m) > 0.5_wp * surf_lsm_h%z_mo(m) )  THEN
-             surf_lsm_h%z0(m) = 0.5_wp * surf_lsm_h%z_mo(m)
-             flag_exceed_z0   = .TRUE.
-          ENDIF
-          IF ( surf_lsm_h%z0h(m) > 0.5_wp * surf_lsm_h%z_mo(m) )  THEN
-             surf_lsm_h%z0h(m) = 0.5_wp * surf_lsm_h%z_mo(m)
-             surf_lsm_h%z0q(m) = 0.5_wp * surf_lsm_h%z_mo(m)
-             flag_exceed_z0h   = .TRUE.
-          ENDIF
+       DO l = 0, 1
+          DO  m = 1, surf_lsm_h(l)%ns
+             IF ( surf_lsm_h(l)%z0(m) > 0.5_wp * surf_lsm_h(l)%z_mo(m) )  THEN
+                surf_lsm_h(l)%z0(m) = 0.5_wp * surf_lsm_h(l)%z_mo(m)
+                flag_exceed_z0   = .TRUE.
+             ENDIF
+             IF ( surf_lsm_h(l)%z0h(m) > 0.5_wp * surf_lsm_h(l)%z_mo(m) )  THEN
+                surf_lsm_h(l)%z0h(m) = 0.5_wp * surf_lsm_h(l)%z_mo(m)
+                surf_lsm_h(l)%z0q(m) = 0.5_wp * surf_lsm_h(l)%z_mo(m)
+                flag_exceed_z0h   = .TRUE.
+             ENDIF
+          ENDDO
        ENDDO
 #if defined( __parallel )
@@ -5102,12 +5208,14 @@
 !
 !--    Horizontal surfaces
-       ALLOCATE ( m_liq_h_1%var_1d(1:surf_lsm_h%ns)                      )
-       ALLOCATE ( m_liq_h_2%var_1d(1:surf_lsm_h%ns)                      )
-       ALLOCATE ( t_surface_h_1%var_1d(1:surf_lsm_h%ns)                  )
-       ALLOCATE ( t_surface_h_2%var_1d(1:surf_lsm_h%ns)                  )
-       ALLOCATE ( m_soil_h_1%var_2d(nzb_soil:nzt_soil,1:surf_lsm_h%ns)   )
-       ALLOCATE ( m_soil_h_2%var_2d(nzb_soil:nzt_soil,1:surf_lsm_h%ns)   )
-       ALLOCATE ( t_soil_h_1%var_2d(nzb_soil:nzt_soil+1,1:surf_lsm_h%ns) )
-       ALLOCATE ( t_soil_h_2%var_2d(nzb_soil:nzt_soil+1,1:surf_lsm_h%ns) )
+       DO l = 0, 1
+          ALLOCATE ( m_liq_h_1(l)%var_1d(1:surf_lsm_h(l)%ns)                      )
+          ALLOCATE ( m_liq_h_2(l)%var_1d(1:surf_lsm_h(l)%ns)                      )
+          ALLOCATE ( t_surface_h_1(l)%var_1d(1:surf_lsm_h(l)%ns)                  )
+          ALLOCATE ( t_surface_h_2(l)%var_1d(1:surf_lsm_h(l)%ns)                  )
+          ALLOCATE ( m_soil_h_1(l)%var_2d(nzb_soil:nzt_soil,1:surf_lsm_h(l)%ns)   )
+          ALLOCATE ( m_soil_h_2(l)%var_2d(nzb_soil:nzt_soil,1:surf_lsm_h(l)%ns)   )
+          ALLOCATE ( t_soil_h_1(l)%var_2d(nzb_soil:nzt_soil+1,1:surf_lsm_h(l)%ns) )
+          ALLOCATE ( t_soil_h_2(l)%var_2d(nzb_soil:nzt_soil+1,1:surf_lsm_h(l)%ns) )
+       ENDDO
 !
 !--    Vertical surfaces
@@ -5126,5 +5234,7 @@
 !--    Allocate array for heat flux in W/m2, required for radiation?
 !--    Consider to remove this array
-       ALLOCATE( surf_lsm_h%surfhf(1:surf_lsm_h%ns) )
+       DO l = 0, 1
+          ALLOCATE( surf_lsm_h(l)%surfhf(1:surf_lsm_h(l)%ns) )
+       ENDDO
        DO  l = 0, 3
           ALLOCATE( surf_lsm_v(l)%surfhf(1:surf_lsm_v(l)%ns) )
@@ -5135,8 +5245,10 @@
 !--    Allocate intermediate timestep arrays
 !--    Horizontal surfaces
-       ALLOCATE ( tm_liq_h_m%var_1d(1:surf_lsm_h%ns)                     )
-       ALLOCATE ( tt_surface_h_m%var_1d(1:surf_lsm_h%ns)                 )
-       ALLOCATE ( tm_soil_h_m%var_2d(nzb_soil:nzt_soil,1:surf_lsm_h%ns)  )
-       ALLOCATE ( tt_soil_h_m%var_2d(nzb_soil:nzt_soil,1:surf_lsm_h%ns)  )
+       DO l = 0, 1
+          ALLOCATE ( tm_liq_h_m(l)%var_1d(1:surf_lsm_h(l)%ns)                     )
+          ALLOCATE ( tt_surface_h_m(l)%var_1d(1:surf_lsm_h(l)%ns)                 )
+          ALLOCATE ( tm_soil_h_m(l)%var_2d(nzb_soil:nzt_soil,1:surf_lsm_h(l)%ns)  )
+          ALLOCATE ( tt_soil_h_m(l)%var_2d(nzb_soil:nzt_soil,1:surf_lsm_h(l)%ns)  )
+       ENDDO
 !
 !--    Horizontal surfaces
@@ -5151,37 +5263,38 @@
 !--    Allocate 2D vegetation model arrays
 !--    Horizontal surfaces
-       ALLOCATE ( surf_lsm_h%building_surface(1:surf_lsm_h%ns)    )
-       ALLOCATE ( surf_lsm_h%c_liq(1:surf_lsm_h%ns)               )
-       ALLOCATE ( surf_lsm_h%c_surface(1:surf_lsm_h%ns)           )
-       ALLOCATE ( surf_lsm_h%c_veg(1:surf_lsm_h%ns)               )
-       ALLOCATE ( surf_lsm_h%f_sw_in(1:surf_lsm_h%ns)             )
-       ALLOCATE ( surf_lsm_h%ghf(1:surf_lsm_h%ns)                 )
-       ALLOCATE ( surf_lsm_h%g_d(1:surf_lsm_h%ns)                 )
-       ALLOCATE ( surf_lsm_h%lai(1:surf_lsm_h%ns)                 )
-       ALLOCATE ( surf_lsm_h%lambda_surface_u(1:surf_lsm_h%ns)    )
-       ALLOCATE ( surf_lsm_h%lambda_surface_s(1:surf_lsm_h%ns)    )
-       ALLOCATE ( surf_lsm_h%nzt_pavement(1:surf_lsm_h%ns)        )
-       ALLOCATE ( surf_lsm_h%pavement_surface(1:surf_lsm_h%ns)    )
-       ALLOCATE ( surf_lsm_h%qsws_soil(1:surf_lsm_h%ns)           )
-       ALLOCATE ( surf_lsm_h%qsws_liq(1:surf_lsm_h%ns)            )
-       ALLOCATE ( surf_lsm_h%qsws_veg(1:surf_lsm_h%ns)            )
-       ALLOCATE ( surf_lsm_h%rad_net_l(1:surf_lsm_h%ns)           )
-       ALLOCATE ( surf_lsm_h%r_a(1:surf_lsm_h%ns)                 )
-       ALLOCATE ( surf_lsm_h%r_canopy(1:surf_lsm_h%ns)            )
-       ALLOCATE ( surf_lsm_h%r_soil(1:surf_lsm_h%ns)              )
-       ALLOCATE ( surf_lsm_h%r_soil_min(1:surf_lsm_h%ns)          )
-       ALLOCATE ( surf_lsm_h%r_s(1:surf_lsm_h%ns)                 )
-       ALLOCATE ( surf_lsm_h%r_canopy_min(1:surf_lsm_h%ns)        )
-       ALLOCATE ( surf_lsm_h%vegetation_surface(1:surf_lsm_h%ns)  )
-       ALLOCATE ( surf_lsm_h%water_surface(1:surf_lsm_h%ns)       )
-
-       surf_lsm_h%water_surface        = .FALSE.
-       surf_lsm_h%pavement_surface     = .FALSE.
-       surf_lsm_h%vegetation_surface   = .FALSE.
-
-!
-!--    Set default values
-       surf_lsm_h%r_canopy_min = 0.0_wp
-
+       DO l = 0, 1
+          ALLOCATE ( surf_lsm_h(l)%building_surface(1:surf_lsm_h(l)%ns)    )
+          ALLOCATE ( surf_lsm_h(l)%c_liq(1:surf_lsm_h(l)%ns)               )
+          ALLOCATE ( surf_lsm_h(l)%c_surface(1:surf_lsm_h(l)%ns)           )
+          ALLOCATE ( surf_lsm_h(l)%c_veg(1:surf_lsm_h(l)%ns)               )
+          ALLOCATE ( surf_lsm_h(l)%f_sw_in(1:surf_lsm_h(l)%ns)             )
+          ALLOCATE ( surf_lsm_h(l)%ghf(1:surf_lsm_h(l)%ns)                 )
+          ALLOCATE ( surf_lsm_h(l)%g_d(1:surf_lsm_h(l)%ns)                 )
+          ALLOCATE ( surf_lsm_h(l)%lai(1:surf_lsm_h(l)%ns)                 )
+          ALLOCATE ( surf_lsm_h(l)%lambda_surface_u(1:surf_lsm_h(l)%ns)    )
+          ALLOCATE ( surf_lsm_h(l)%lambda_surface_s(1:surf_lsm_h(l)%ns)    )
+          ALLOCATE ( surf_lsm_h(l)%nzt_pavement(1:surf_lsm_h(l)%ns)        )
+          ALLOCATE ( surf_lsm_h(l)%pavement_surface(1:surf_lsm_h(l)%ns)    )
+          ALLOCATE ( surf_lsm_h(l)%qsws_soil(1:surf_lsm_h(l)%ns)           )
+          ALLOCATE ( surf_lsm_h(l)%qsws_liq(1:surf_lsm_h(l)%ns)            )
+          ALLOCATE ( surf_lsm_h(l)%qsws_veg(1:surf_lsm_h(l)%ns)            )
+          ALLOCATE ( surf_lsm_h(l)%rad_net_l(1:surf_lsm_h(l)%ns)           )
+          ALLOCATE ( surf_lsm_h(l)%r_a(1:surf_lsm_h(l)%ns)                 )
+          ALLOCATE ( surf_lsm_h(l)%r_canopy(1:surf_lsm_h(l)%ns)            )
+          ALLOCATE ( surf_lsm_h(l)%r_soil(1:surf_lsm_h(l)%ns)              )
+          ALLOCATE ( surf_lsm_h(l)%r_soil_min(1:surf_lsm_h(l)%ns)          )
+          ALLOCATE ( surf_lsm_h(l)%r_s(1:surf_lsm_h(l)%ns)                 )
+          ALLOCATE ( surf_lsm_h(l)%r_canopy_min(1:surf_lsm_h(l)%ns)        )
+          ALLOCATE ( surf_lsm_h(l)%vegetation_surface(1:surf_lsm_h(l)%ns)  )
+          ALLOCATE ( surf_lsm_h(l)%water_surface(1:surf_lsm_h(l)%ns)       )
+
+          surf_lsm_h(l)%water_surface        = .FALSE.
+          surf_lsm_h(l)%pavement_surface     = .FALSE.
+          surf_lsm_h(l)%vegetation_surface   = .FALSE.
+
+!
+!--       Set default values
+          surf_lsm_h(l)%r_canopy_min = 0.0_wp
+       ENDDO
 !
 !--    Vertical surfaces
@@ -5410,12 +5523,12 @@
 
        IF ( horizontal )  THEN
-          surf           => surf_lsm_h
-
-          surf_m_soil    => m_soil_h
-          surf_m_soil_p  => m_soil_h_p
-          surf_t_soil    => t_soil_h
-          surf_t_soil_p  => t_soil_h_p
-          surf_tm_soil_m => tm_soil_h_m
-          surf_tt_soil_m => tt_soil_h_m
+          surf           => surf_lsm_h(l)
+
+          surf_m_soil    => m_soil_h(l)
+          surf_m_soil_p  => m_soil_h_p(l)
+          surf_t_soil    => t_soil_h(l)
+          surf_t_soil_p  => t_soil_h_p(l)
+          surf_tm_soil_m => tm_soil_h_m(l)
+          surf_tt_soil_m => tt_soil_h_m(l)
        ELSE
           surf           => surf_lsm_v(l)
@@ -5880,8 +5993,8 @@
           CASE ( 'c_liq*' )
              IF ( ALLOCATED( c_liq_av ) ) THEN
-                DO  m = 1, surf_lsm_h%ns
-                   i   = surf_lsm_h%i(m)
-                   j   = surf_lsm_h%j(m)
-                   c_liq_av(j,i) = c_liq_av(j,i) + surf_lsm_h%c_liq(m)
+                DO  m = 1, surf_lsm_h(0)%ns
+                   i   = surf_lsm_h(0)%i(m)
+                   j   = surf_lsm_h(0)%j(m)
+                   c_liq_av(j,i) = c_liq_av(j,i) + surf_lsm_h(0)%c_liq(m)
                 ENDDO
              ENDIF
@@ -5889,8 +6002,8 @@
           CASE ( 'c_soil*' )
              IF ( ALLOCATED( c_soil_av ) ) THEN
-                DO  m = 1, surf_lsm_h%ns
-                   i   = surf_lsm_h%i(m)
-                   j   = surf_lsm_h%j(m)
-                   c_soil_av(j,i) = c_soil_av(j,i) + (1.0 - surf_lsm_h%c_veg(m))
+                DO  m = 1, surf_lsm_h(0)%ns
+                   i   = surf_lsm_h(0)%i(m)
+                   j   = surf_lsm_h(0)%j(m)
+                   c_soil_av(j,i) = c_soil_av(j,i) + (1.0 - surf_lsm_h(0)%c_veg(m))
                 ENDDO
              ENDIF
@@ -5898,8 +6011,8 @@
           CASE ( 'c_veg*' )
              IF ( ALLOCATED( c_veg_av ) ) THEN
-                DO  m = 1, surf_lsm_h%ns
-                   i   = surf_lsm_h%i(m)
-                   j   = surf_lsm_h%j(m)
-                   c_veg_av(j,i) = c_veg_av(j,i) + surf_lsm_h%c_veg(m)
+                DO  m = 1, surf_lsm_h(0)%ns
+                   i   = surf_lsm_h(0)%i(m)
+                   j   = surf_lsm_h(0)%j(m)
+                   c_veg_av(j,i) = c_veg_av(j,i) + surf_lsm_h(0)%c_veg(m)
                 ENDDO
              ENDIF
@@ -5907,8 +6020,8 @@
           CASE ( 'lai*' )
              IF ( ALLOCATED( lai_av ) ) THEN
-                DO  m = 1, surf_lsm_h%ns
-                   i   = surf_lsm_h%i(m)
-                   j   = surf_lsm_h%j(m)
-                   lai_av(j,i) = lai_av(j,i) + surf_lsm_h%lai(m)
+                DO  m = 1, surf_lsm_h(0)%ns
+                   i   = surf_lsm_h(0)%i(m)
+                   j   = surf_lsm_h(0)%j(m)
+                   lai_av(j,i) = lai_av(j,i) + surf_lsm_h(0)%lai(m)
                 ENDDO
              ENDIF
@@ -5916,8 +6029,8 @@
           CASE ( 'm_liq*' )
              IF ( ALLOCATED( m_liq_av ) ) THEN
-                DO  m = 1, surf_lsm_h%ns
-                   i   = surf_lsm_h%i(m)
-                   j   = surf_lsm_h%j(m)
-                   m_liq_av(j,i) = m_liq_av(j,i) + m_liq_h%var_1d(m)
+                DO  m = 1, surf_lsm_h(0)%ns
+                   i   = surf_lsm_h(0)%i(m)
+                   j   = surf_lsm_h(0)%j(m)
+                   m_liq_av(j,i) = m_liq_av(j,i) + m_liq_h(0)%var_1d(m)
                 ENDDO
              ENDIF
@@ -5925,9 +6038,9 @@
           CASE ( 'm_soil' )
              IF ( ALLOCATED( m_soil_av ) ) THEN
-                DO  m = 1, surf_lsm_h%ns
-                   i   = surf_lsm_h%i(m)
-                   j   = surf_lsm_h%j(m)
+                DO  m = 1, surf_lsm_h(0)%ns
+                   i   = surf_lsm_h(0)%i(m)
+                   j   = surf_lsm_h(0)%j(m)
                    DO  k = nzb_soil, nzt_soil
-                      m_soil_av(k,j,i) = m_soil_av(k,j,i) + m_soil_h%var_2d(k,m)
+                      m_soil_av(k,j,i) = m_soil_av(k,j,i) + m_soil_h(0)%var_2d(k,m)
                    ENDDO
                 ENDDO
@@ -5936,9 +6049,9 @@
           CASE ( 'qsws_liq*' )
              IF ( ALLOCATED( qsws_liq_av ) ) THEN
-                DO  m = 1, surf_lsm_h%ns
-                   i   = surf_lsm_h%i(m)
-                   j   = surf_lsm_h%j(m)
+                DO  m = 1, surf_lsm_h(0)%ns
+                   i   = surf_lsm_h(0)%i(m)
+                   j   = surf_lsm_h(0)%j(m)
                    qsws_liq_av(j,i) = qsws_liq_av(j,i) +                       &
-                                         surf_lsm_h%qsws_liq(m)
+                                         surf_lsm_h(0)%qsws_liq(m)
                 ENDDO
              ENDIF
@@ -5946,9 +6059,9 @@
           CASE ( 'qsws_soil*' )
              IF ( ALLOCATED( qsws_soil_av ) ) THEN
-                DO  m = 1, surf_lsm_h%ns
-                   i   = surf_lsm_h%i(m)
-                   j   = surf_lsm_h%j(m)
+                DO  m = 1, surf_lsm_h(0)%ns
+                   i   = surf_lsm_h(0)%i(m)
+                   j   = surf_lsm_h(0)%j(m)
                    qsws_soil_av(j,i) = qsws_soil_av(j,i) +                     &
-                                          surf_lsm_h%qsws_soil(m)
+                                          surf_lsm_h(0)%qsws_soil(m)
                 ENDDO
              ENDIF
@@ -5956,9 +6069,9 @@
           CASE ( 'qsws_veg*' )
              IF ( ALLOCATED(qsws_veg_av ) ) THEN
-                DO  m = 1, surf_lsm_h%ns
-                   i   = surf_lsm_h%i(m)
-                   j   = surf_lsm_h%j(m)
+                DO  m = 1, surf_lsm_h(0)%ns
+                   i   = surf_lsm_h(0)%i(m)
+                   j   = surf_lsm_h(0)%j(m)
                    qsws_veg_av(j,i) = qsws_veg_av(j,i) +                       &
-                                         surf_lsm_h%qsws_veg(m)
+                                         surf_lsm_h(0)%qsws_veg(m)
                 ENDDO
              ENDIF
@@ -5966,8 +6079,8 @@
           CASE ( 'r_s*' )
              IF ( ALLOCATED( r_s_av) ) THEN
-                DO  m = 1, surf_lsm_h%ns
-                   i   = surf_lsm_h%i(m)
-                   j   = surf_lsm_h%j(m)
-                   r_s_av(j,i) = r_s_av(j,i) + surf_lsm_h%r_s(m)
+                DO  m = 1, surf_lsm_h(0)%ns
+                   i   = surf_lsm_h(0)%i(m)
+                   j   = surf_lsm_h(0)%j(m)
+                   r_s_av(j,i) = r_s_av(j,i) + surf_lsm_h(0)%r_s(m)
                 ENDDO
              ENDIF
